Index: /trunk/AddOn/TAcq/pciewrap.cc
===================================================================
--- /trunk/AddOn/TAcq/pciewrap.cc	(revision 3627)
+++ /trunk/AddOn/TAcq/pciewrap.cc	(revision 3628)
@@ -9,6 +9,7 @@
 #include <iostream>
 
+/* --Methode-- */
 TestPCIWrapperNODMA::TestPCIWrapperNODMA(UInt32 sz) 
-  : PCIEWrapper() , size_(sz)
+  : PCIEWrapperInterface() , size_(sz)
 {
   data_ = new Byte[size_];
@@ -18,4 +19,5 @@
 }
 
+/* --Methode-- */
 TestPCIWrapperNODMA::~TestPCIWrapperNODMA()
 {
@@ -23,4 +25,5 @@
 }
 
+/* --Methode-- */
 UInt32 TestPCIWrapperNODMA::TransferSize()
 {
@@ -28,4 +31,5 @@
 }
 
+/* --Methode-- */
 UInt64 TestPCIWrapperNODMA::TotTransferBytes()
 {
@@ -33,4 +37,5 @@
 }
 
+/* --Methode-- */
 Byte* TestPCIWrapperNODMA::DoTransferData(int numbuff)
 {
@@ -55,4 +60,5 @@
 }
 
+/* --Methode-- */
 void TestPCIWrapperNODMA::PrintStatus(ostream& os) 
 {
Index: /trunk/AddOn/TAcq/pciewrap.h
===================================================================
--- /trunk/AddOn/TAcq/pciewrap.h	(revision 3627)
+++ /trunk/AddOn/TAcq/pciewrap.h	(revision 3628)
@@ -28,10 +28,10 @@
 
 // Classe definissant l'interface des operations transfert DMA/PCIExpress 
-class PCIEWrapper {
+class PCIEWrapperInterface {
  public:
   // Constructeur - fait l'initialisation
-  PCIEWrapper() { } 
+  PCIEWrapperInterface() { } 
   // destructeur - libere la memoire allouee
-  virtual ~PCIEWrapper() { } 
+  virtual ~PCIEWrapperInterface() { } 
 
   virtual UInt32 TransferSize() = 0;
@@ -42,5 +42,5 @@
 
 // Classe de test Implementant l'interface PCIEWrapper sans DMA 
-class TestPCIWrapperNODMA : public PCIEWrapper {
+class TestPCIWrapperNODMA : public PCIEWrapperInterface {
 public:	
   TestPCIWrapperNODMA(UInt32 sz);
Index: /trunk/AddOn/TAcq/racqurw.cc
===================================================================
--- /trunk/AddOn/TAcq/racqurw.cc	(revision 3627)
+++ /trunk/AddOn/TAcq/racqurw.cc	(revision 3628)
@@ -25,5 +25,5 @@
 //-------------------------------------------------------
 
-PCIEReader::PCIEReader(PCIEWrapper &pciw,uint_4 sizeFrame,uint_4 packSize ,RAcqMemZoneMgr& mem, 
+PCIEReader::PCIEReader(PCIEWrapperInterface &pciw,uint_4 sizeFrame,uint_4 packSize ,RAcqMemZoneMgr& mem, 
 		       uint_4 nmax, BRDataFmtConv swapall)
   :   memgr(mem) , pciw_ (pciw)
@@ -319,5 +319,5 @@
 //----------------------------------------------------------------------------------------------------------
 
-PCIEReaderChecker::PCIEReaderChecker(PCIEWrapper &pciw,uint_4 sizeFrame,uint_4 packSize ,RAcqMemZoneMgr& mem, 
+PCIEReaderChecker::PCIEReaderChecker(PCIEWrapperInterface &pciw,uint_4 sizeFrame,uint_4 packSize ,RAcqMemZoneMgr& mem, 
 				     uint_4 nmax, BRDataFmtConv swapall)
   :   memgr(mem) , pciw_ (pciw)
Index: /trunk/AddOn/TAcq/racqurw.h
===================================================================
--- /trunk/AddOn/TAcq/racqurw.h	(revision 3627)
+++ /trunk/AddOn/TAcq/racqurw.h	(revision 3628)
@@ -29,5 +29,5 @@
 class PCIEReader : public ZThread {
 public:
-  PCIEReader( PCIEWrapper &pciw , uint_4 sizeFrame,uint_4 paqSize ,RAcqMemZoneMgr& mem, 
+  PCIEReader( PCIEWrapperInterface &pciw , uint_4 sizeFrame,uint_4 paqSize ,RAcqMemZoneMgr& mem, 
 	      uint_4 nmax=100, BRDataFmtConv swapall=BR_SwapAll);	
   virtual void run(); 
@@ -51,5 +51,5 @@
   bool stop_;  
   unsigned int sizeFr_ ;
-  PCIEWrapper& pciw_;
+  PCIEWrapperInterface& pciw_;
   uint_4 packSize_;
   // Variables pour gerer la logique de  NextPaqTarget() qui cache l'acces a RAcqMemZoneMgr
@@ -89,5 +89,5 @@
 class PCIEReaderChecker : public ZThread {
 public:
-  PCIEReaderChecker( PCIEWrapper &pciw , uint_4 sizeFrame,uint_4 paqSize ,RAcqMemZoneMgr& mem, 
+  PCIEReaderChecker( PCIEWrapperInterface &pciw , uint_4 sizeFrame,uint_4 paqSize ,RAcqMemZoneMgr& mem, 
 		     uint_4 nmax=100, BRDataFmtConv swapall=BR_SwapAll);  
   virtual void run(); 
@@ -100,5 +100,5 @@
   bool stop_;  
   unsigned int sizeFr_ ;
-  PCIEWrapper& pciw_;
+  PCIEWrapperInterface& pciw_;
   uint_4 packSize_;
 };
Index: /trunk/AddOn/TAcq/tmtacq.cc
===================================================================
--- /trunk/AddOn/TAcq/tmtacq.cc	(revision 3627)
+++ /trunk/AddOn/TAcq/tmtacq.cc	(revision 3628)
@@ -189,4 +189,5 @@
     }
     else cout << " tmtacq[0] - fibre accrochee OK " << endl;
+    PCIEWrapper pciw(dma1); 
 #endif    
     RAcqMemZoneMgr mmgr(nZones, nPaqZone, PaqSZ);